package superuserPOC.server;

import com.intellij.openapi.diagnostic.Logger;
import com.intellij.openapi.util.text.StringUtil;
import jetbrains.buildServer.log.Loggers;
import jetbrains.buildServer.serverSide.BuildServerAdapter;
import jetbrains.buildServer.serverSide.BuildServerListener;
import jetbrains.buildServer.util.EventDispatcher;

/**
 * @author Yegor.Yarko
 *         Date: 19.11.12
 */
public class ServerListener extends BuildServerAdapter {
  final static Logger LOG = Logger.getInstance(ServerListener.class.getName());

  private SuperUserData mySuperUserData;

  public ServerListener(SuperUserData superUserData, final EventDispatcher<BuildServerListener> dispatcher) {
    dispatcher.addListener(this);
    mySuperUserData = superUserData;
  }

  @Override
  public void serverStartup() {
    final String authenticationToken = mySuperUserData.getAuthenticationToken();
    Loggers.SERVER.info("Authentication token for superuser generated: '" + authenticationToken);
    if (!StringUtil.isEmpty(authenticationToken)) {
      Loggers.SERVER.info("Become any user by adding the following parameters to yet unauthenticated request: ?" +
                          SuperUserData.USERNAME_PARAMETER_NAME + "=<any username>&" + SuperUserData.TOKEN_PARAMETER_NAME + "=" +
                          authenticationToken + "&userKey=newUser");
    }
  }
}
